/**************** -*- mode: java -*- ***************************

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is Aphrodite Development Team code.

The Initial Developer of the Original Code is Aphrodite
Development Team.  Portions created by Aphrodite
Development Team are Copyright (C) 1999-2001
Aphrodite Development Team.
All Rights Reserved.

Contributor(s): 
                       Mark Anderson 
                       David Boswell 
                       Jeff Campbell 
                       Pete Collins 
                       Lorenzo De Tomasi 
                       Neil Deakin 
                       John Dobbins 
                       Klein Duijmpje 
                       Ben Goodger 
                       Julia Kleyman 
                       Lemming 
                       Aaron Leventhal 
                       Jason LoBrutto 
                       Anders Lund 
                       Petrus Lundqvist 
                       Brian Mathis 
                       Yusuf Motara 
                       Chris Nelson 
                       Robert O'Connor 
                       Isriya Paireepairit 
                       Dan Ridley 
                       Richard Shaw 
                       Tekhir 
                       Matthew Thomas 
                       Waldo 

**********************************************************/

/**************************** QUIT **********************************/

function goQuitApplication() {

  var windowManager = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService();
  var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
  var enumerator = windowManagerInterface.getEnumerator( null );

  while ( enumerator.hasMoreElements()  )
  {
    var  windowToClose = enumerator.getNext();
    var domWindow = windowManagerInterface.convertISupportsToDOMWindow( windowToClose );
    domWindow.focus();
    if ( domWindow.tryToClose == null )
    {
      domWindow.close();
    }
    else
    {
      if ( !domWindow.tryToClose() )
        return false;
    }
  };

  var appShell = Components.classes['@mozilla.org/appshell/appShellService;1'].getService();
  appShell = appShell.QueryInterface( Components.interfaces.nsIAppShellService );
  appShell.Quit();
  return true;

}

/**************************** QUIT **********************************/

/***************** Command Updater functions *****************/

function goUpdateCommand(command)
{
  try {
    var controller = top.document.commandDispatcher.getControllerForCommand(command);

    var enabled = false;

    if ( controller )
      enabled = controller.isCommandEnabled(command);

    goSetCommandEnabled(command, enabled);
  }
  catch (e) {
    dump("An error occurred updating the "+command+" command\n");
  }
}

function goDoCommand(command)
{
  try {
    var controller = top.document.commandDispatcher.getControllerForCommand(command);
    if ( controller && controller.isCommandEnabled(command))
      controller.doCommand(command);
  }
  catch (e) {
    dump("An error occurred executing the "+command+" command\n");
  }
}


function goSetCommandEnabled(id, enabled)
{
  var node = document.getElementById(id);

  if ( node )
  {
    if ( enabled )
      node.removeAttribute("disabled");
    else
      node.setAttribute('disabled', 'true');
  }
}

function goSetMenuValue(command, labelAttribute)
{
  var commandNode = top.document.getElementById(command);
  if ( commandNode )
  {
    var label = commandNode.getAttribute(labelAttribute);
    if ( label )
      commandNode.setAttribute('label', label);
  }
}

function goSetAccessKey(command, valueAttribute)
{
  var commandNode = top.document.getElementById(command);
  if ( commandNode )
  {
    var value = commandNode.getAttribute(valueAttribute);
    if ( value )
      commandNode.setAttribute('accesskey', value);
  }
}

// this function is used to inform all the controllers attached to a node that an event has occurred
// (e.g. the tree controllers need to be informed of blur events so that they can change some of the
// menu items back to their default values)
function goOnEvent(node, event)
{
  var numControllers = node.controllers.getControllerCount();
  var controller;

  for ( var controllerIndex = 0; controllerIndex < numControllers; controllerIndex++ )
  {
    controller = node.controllers.getControllerAt(controllerIndex);
    if ( controller )
      controller.onEvent(event);
  }
}

function goUpdateGlobalEditMenuItems() {
        goUpdateCommand('cmd_undo');
        goUpdateCommand('cmd_redo');
        goUpdateCommand('cmd_cut');
        goUpdateCommand('cmd_copy');
        goUpdateCommand('cmd_paste');
        goUpdateCommand('cmd_pasteQuote');
        goUpdateCommand('cmd_selectAll');
        goUpdateCommand('cmd_delete');
}


function goUpdateSelectEditMenuItems(){
        goUpdateCommand('cmd_cut');
        goUpdateCommand('cmd_copy');
        goUpdateCommand('cmd_delete');
}


function goUpdateUndoEditMenuItems(){

        goUpdateCommand('cmd_undo');
        goUpdateCommand('cmd_redo');

        // we shouldn't really do this here, but we don't get the right notifications now
        goUpdateCommand('cmd_paste');
        goUpdateCommand('cmd_pasteQuote');
}

/***************** Command Updater functions *****************/
