/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s):
 *  Jason Eager <jce2@po.cwru.edu>
 *  Blake Ross <BlakeR1234@aol.com>
 *  Peter Annema <disttsc@bart.nl>
 *  Anders Lund <anders@alweb.dk>
 *
 */

function updateGoMenu(event) {
  createDocRelMenuItems(event.target);
  parent.appCore.updateGoMenu(event.target);
}

/**
 * createDocRelMenuItems
 * add the logical relation links of current document to Go menu if any
 *   -anders, 01/11/2000
 */
var linkwin;
function createDocRelMenuItems(aMenu) {
  deleteRelItems(aMenu);
  var doc = window._content.document;
  var haslinks = false;
  linkwin = window._content;
  // if some unfortunate author conned us into
  // a frameset, look for a focused frame...
  if (window._content.frames.length && isDocumentFrame(document.commandDispatcher.focusedWindow)) {
    doc = document.commandDispatcher.focusedWindow.document;
    linkwin = document.commandDispatcher.focusedWindow;
  }
  var rels = doc.getElementsByTagName("LINK");
  for (var i = 0; i < rels.length; i++) {
    var r = rels[i].getAttribute("REL");
    // skip style sheet links
    var test = r;
    if (test && test.toLowerCase() == 'stylesheet')
      continue;
    var u = rels[i].getAttribute("HREF");
    var t = rels[i].getAttribute("TITLE");
    if (!t)
      t = u; // if they didn't provide a title, use the raw href
    t = t.replace(/\s+/g, " ");
    //dump("Relation: " + r + " = " + t + " (" + u + ")\n");
    // If the link is a relative URL, try to resolve it.
    // Unfortunately, someone at netscape forgot to allow
    // var aLink = new Link(aURL)
    // so this is a bit in inconvenient...
    // If the url dosent have some letters followed by a colon,
    // prepend the protocol of current document after looking for
    // a "?\.+/" and
    // applying a resonable path depending on that.
    if (!u.match(/\w+:.+/)) {
      //dump("uuuh, this is a bad url: " + u + "\n");
      var prot = doc.location.protocol;
      var host = doc.location.hostname;
      //dump("doc protocol: " + prot + "\n");
      //dump("doc host: " + host + "\n");
      if (u.match(/^\.\.\//)) {
        // Wer'e in some relative URL like
        // ../foo/bar/file
        // Not very likely, but anyways...
        var docpath = linkwin.location.pathname;
        var parts = docpath.split("/");
        if (!docpath.match(/\/$/)) // remove filename
          parts.pop();
        var uparts = u.split("/");
        var cut = 0;
        for (var j = 0; j < uparts.length; j++) {
          if (uparts[i] == "..") {
            cut++;
            parts.pop();
          } else {
            continue;
          }
        }
        uparts.splice(0, cut);
        parts.concat(uparts);
        u = prot + host + parts.join("/");
      } else if (u.match(/^\//)) {
        // This is a relative link, starting at / on server
        // (or a unix file)
        // Just prepend protocol
        u = prot + host + u;
      } else {
        // a ./ (or \w) link, we stay in current directory.
        // lastIndexOf("/") is _not_ good, FIXME!!
        u.replace(/^\.\//, '');
        var dirUrl = doc.location.href.substring(0,doc.location.href.lastIndexOf("/") + 1);
        u = dirUrl + u;
      }
    }
    //dump ("LINK URL: " + u + "\n");
    createRelMenuItem(aMenu, r, u, t);
    haslinks = true;
  }
  if (haslinks) {
    var sep = document.createElement("menuseparator");
    sep.setAttribute("class", "relmenuitem");
    aMenu.appendChild(sep);
  }
}

/**
 * isDocumentFrame
 * stolen from chrome/navigator/content/navigator.js
 *   -anders
 */
function isDocumentFrame(aFocusedWindow)
{
  var contentFrames = window._content.frames;
  if (contentFrames.length) {
    for (var i = 0; i < contentFrames.length; i++ ) {
      if (aFocusedWindow == contentFrames[i])
        return true;
    }
  }
  return false;
}

/**
 * deleteRelItems
 * Destroy old relation menu items from a menu
 * (before attempting to add new ones)
 *   -anders, 01/11/2000
 */
function deleteRelItems(aMenu) {
  var children = aMenu.childNodes;
  for (var i = 0; i < children.length; i++) {
    if (children[i].getAttribute("class") == "relmenuitem")
      aMenu.removeChild(children[i]);
  }
}

/**
 * createRelMenuItem
 * add a item to a menu, based on
 *   o relation name
 *   o href
 *   o title
 *   -anders, 01/11/2000
 */
function createRelMenuItem(aMenu, aName, aURL, aTitle) {
  var item = document.createElement("menuitem");
  item.setAttribute("class", "relmenuitem");
  item.setAttribute("value", aName + ": " + aTitle);
  item.setAttribute("oncommand", " activateRelMenuItem('" + aURL + "');");
  // set accesskey for some wellknown cases..
  var accesskey;
  if (aName.match(/^next/i))
    accesskey = "n";
  else if (aName.match(/^previous/i))
    accesskey = "p";
  else if (aName.match(/^up/i))
    accesskey = "u";
  else if (aName.match(/^home/i))
    accesskey = "o";
  else if (aName.match(/^content/i))
    accesskey = "c";
  if (accesskey)
    item.setAttribute("accesskey", accesskey);
  aMenu.appendChild(item); 
}

/**
 * activateRelMenuItem
 * loads a specified URL
 *   -anders, 01/11/2000
 */
function activateRelMenuItem(aURL) {
  linkwin.location.href = aURL;
}

const MAX_HISTORY_ITEMS = 100;
const MAX_HISTORY_MENU_ITEMS = 15;
var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService();
rdf = rdf.QueryInterface(Components.interfaces.nsIRDFService);
var rdfc = Components.classes["@mozilla.org/rdf/container-utils;1"].getService(Components.interfaces.nsIRDFContainerUtils);
var localstore = rdf.GetDataSource("rdf:localstore");

function FillHistoryMenu( aParent, aMenu )
  {
    // Get the content area docshell
    var browserElement = document.getElementById("content");
    if (browserElement)
      {
        var docShell = browserElement.boxObject.QueryInterface(Components.interfaces.nsIBrowserBoxObject).docShell;
        if (docShell)
          {
            var webNavigation = docShell.QueryInterface(Components.interfaces.nsIWebNavigation);
            if (webNavigation)
              {
                var shistory = webNavigation.sessionHistory;
                if (shistory)
                  {
                    //Remove old entries if any
                    deleteHistoryItems( aParent );
                    var count = shistory.count;
                    var index = shistory.index;
                    var end;
                    var j;
                    var entry;
                    
                    switch (aMenu)
                      {
                        case "back":
                          end = (index > MAX_HISTORY_MENU_ITEMS) ? index - MAX_HISTORY_MENU_ITEMS : 0;
                          for ( j = index - 1; j >= end; j--) 
                            {
                              entry = shistory.getEntryAtIndex(j, false);
                              if (entry) 
                                createMenuItem( aParent, j, entry.title );
                            }
                          break;
                        case "forward":
                          end  = ((count-index) > MAX_HISTORY_MENU_ITEMS) ? index + MAX_HISTORY_MENU_ITEMS : count;
                          for ( j = index + 1; j < end; j++)
                            {
                              entry = shistory.getEntryAtIndex(j, false);
                              if (entry)
                                createMenuItem( aParent, j, entry.title );
                            }
                          break;
                        case "go":
                          end = count > MAX_HISTORY_MENU_ITEMS ? count - MAX_HISTORY_MENU_ITEMS : 0;
                          for( j = count - 1; j >= end; j-- )
                            {
                              entry = shistory.getEntryAtIndex(j, false);
                              if (entry)
                                createCheckboxMenuItem( aParent, j, entry.title, j==index );
                            }
                          break;
                      }
                  }
              }
          }
      }
  }


function executeUrlBarHistoryCommand( aTarget)
  {
    var index = aTarget.getAttribute("index");
    var value = aTarget.getAttribute("value");
    if (index != "nothing_available" && value)
      {
        var gURLBar = document.getElementById("urlbar");
        gURLBar.value = value;
        BrowserLoadURL();
      }
  }

function createUBHistoryMenu( aParent )
  {
    var ubHistory = parent.appCore.urlbarHistory;
    if (localstore) {
      var entries = rdfc.MakeSeq(localstore, rdf.GetResource("nc:urlbar-history")).GetElements();
      var i= MAX_HISTORY_MENU_ITEMS;

      // Delete any old menu items only if there are legitimate
      // urls to display, otherwise we want to display the
      // '(Nothing Available)' item.
	  deleteHistoryItems(aParent);
      if (!entries.hasMoreElements()) {
	    //Create the "Nothing Available" Menu item
		var na = bundle.GetStringFromName( "nothingAvailable" );
		createMenuItem(aParent, "nothing_available", na);
      }

      while (entries.hasMoreElements() && (i-- > 0)) {
        var entry = entries.getNext();
        if (entry) {
          entry = entry.QueryInterface(Components.interfaces.nsIRDFLiteral);
          var url = entry.Value;
          createMenuItem(aParent, i, url);
        }
      }
    }
  }

function addToUrlbarHistory()
  {
    //var ubHistory = appCore.urlbarHistory;
        var gURLBar = document.getElementById("urlbar");
	var urlToAdd = gURLBar.value;
	if (!urlToAdd)
	   return;
	if (localstore) {
    var entries = rdfc.MakeSeq(localstore, rdf.GetResource("nc:urlbar-history"));
	var entry = rdf.GetLiteral(urlToAdd);
    var index = entries.IndexOf(entry);

    if (index != -1) {
      // we've got it already. Remove it from its old place
      // and insert it to the top
      //dump("URL already in urlbar history\n");
      entries.RemoveElementAt(index, true);
    }

    // Otherwise, we've got a new URL in town. Add it!
    // Put the new entry at the front of the list.
    entries.InsertElementAt(entry, 1, true);

    // Remove any expired history items so that we don't let this grow
    // without bound.
    for (index = entries.GetCount(); index > MAX_HISTORY_ITEMS; --index) {
      entries.RemoveElementAt(index, true);
    }
  }
  }

function createMenuItem( aParent, aIndex, aValue)
  {
    var menuitem = document.createElement( "menuitem" );
    menuitem.setAttribute( "value", aValue );
    menuitem.setAttribute( "index", aIndex );
    aParent.appendChild( menuitem );
  }

function createCheckboxMenuItem( aParent, aIndex, aValue, aChecked)
  {
    var menuitem = document.createElement( "menuitem" );
    menuitem.setAttribute( "type", "checkbox" );
    menuitem.setAttribute( "value", aValue );
    menuitem.setAttribute( "index", aIndex );
    if (aChecked==true)
      menuitem.setAttribute( "checked", "true" );
    aParent.appendChild( menuitem );
  }

function deleteHistoryItems( aParent )
  {
    var children = aParent.childNodes;
    for (var i = 0; i < children.length; i++ )
      {
        var index = children[i].getAttribute( "index" );
        if (index)
          aParent.removeChild( children[i] );
      }
  }

